#init join
execute as @a[tag=!new] at @s run function main:join

#random
team join player @a[team=]
execute unless entity @e[type=armor_stand,tag=as] run setblock -34 88 76 lapis_block
spawnpoint @a 5 114 1 90
execute as @a unless entity @s[x=-9,y=109,z=-20,dx=31,dy=25,dz=39] run tag @s remove inSpawn
tag @a[x=-9,y=109,z=-20,dx=31,dy=25,dz=39] add inSpawn
execute as @a unless entity @s[x=51,y=99,z=150,dx=-98,dy=100,dz=-105] run tag @s remove inArena
tag @a[x=51,y=99,z=150,dx=-98,dy=100,dz=-105] add inArena
effect give @a[tag=inSpawn] saturation 2 0 true
effect give @a[tag=inSpawn] weakness 1 255 true
effect give @a[tag=inSpawn] resistance 1 255 true
effect clear @a mining_fatigue
effect clear @a fire_resistance
execute as @e[type=armor_stand,tag=as] unless entity @s[scores={startTimer=0..}] run team join spec @a[tag=inSpawn]
execute as @e[type=drowned,tag=!logged,nbt=!{IsBaby:1b}] run data merge entity @s {Attributes:[{Name:generic.movement_speed,Base:0.5d}]}
execute as @e[type=drowned,tag=!logged,nbt={IsBaby:1b}] run data merge entity @s {Attributes:[{Name:generic.movement_speed,Base:1d}]}
tag @e[type=drowned,tag=!logged] add logged
advancement grant @a only underwater_mob_arena:root
execute as @a unless entity @s[nbt={EnderItems:[{Slot:13b,id:"minecraft:turtle_egg"}]}] run advancement grant @s only underwater_mob_arena:easter_egg
clear @a turtle_egg
item replace entity @a enderchest.13 with minecraft:turtle_egg{display:{Name:"{\"text\":\"Easter Egg\",\"color\":\"yellow\",\"italic\":\"false\"}"}} 1
gamemode adventure @a[gamemode=survival]
execute as @e[type=area_effect_cloud] run data merge entity @s {Duration:99999}
kill @e[type=item,nbt={Item:{id:"minecraft:turtle_egg"}}]
kill @e[type=item,nbt={Item:{id:"minecraft:totem_of_undying"}}]
bossbar set underwater_mob_arena:wave name [{"text":"--= ","bold":true,"color":"dark_aqua"},{"text":"Wave  ","bold":true,"color":"aqua"},{"score":{"name":"@e[type=armor_stand,tag=as,limit=1]","objective":"wave"},"bold":true,"color":"aqua"},{"text":"/","bold":true,"color":"dark_aqua"},{"text":"20","bold":true,"color":"aqua"},{"text":" =--","bold":true,"color":"dark_aqua"}]
execute as @e[type=item,nbt={Item:{id:"minecraft:sunflower"}}] unless entity @s[type=item,nbt={Item:{tag:{coin:1b}}}] run data merge entity @s {PickupDelay:0s,Motion:[0.0,0.0,0.0]}
execute as @e[type=item,nbt={Item:{id:"minecraft:sunflower"}}] run data merge entity @s {Item:{id: "minecraft:sunflower", tag: {display: {Lore: ['{"italic":false,"color":"gray","text":"Use this in the shop!"}'], Name: '{"italic":false,"color":"yellow","text":"Coin"}'}, coin: 1b}}}
function main:coins
kill @e[type=minecraft:experience_orb]
execute unless entity @e[type=armor_stand,tag=as] run weather clear
execute if entity @a[x=-45,y=94,z=-4,dx=32,dy=25,dz=32] as @e[type=armor_stand,tag=shopHolo] run data merge entity @s {CustomNameVisible:1b}
execute unless entity @a[x=-45,y=94,z=-4,dx=32,dy=25,dz=32] as @e[type=armor_stand,tag=shopHolo] run data merge entity @s {CustomNameVisible:0b}
effect give @e[type=drowned,tag=invis] invisibility 1000000 0 true
effect give @e[type=giant,tag=idol] invisibility 1000000 0 true
item replace entity @e[type=giant,tag=idol] weapon.mainhand with totem_of_undying
execute as @e[type=item] at @s if block ~ ~1 ~ barrier run data merge entity @s {PickupDelay:0s}
execute as @e[type=item] at @s if block ~ ~1 ~ barrier run tp @s @p[team=player,gamemode=!spectator]
function main:starter
function main:perks/main
function main:hp
function main:lobby/main
function main:stars
execute at @e[type=armor_stand,tag=vtModel] positioned ~-0.55 ~1.3 ~-0.4 run particle portal ~ ~0.3 ~ 0 0 0 0.5 1 force
execute unless block -29 99 0 chest[waterlogged=true,facing=south] run setblock -29 99 0 chest[waterlogged=true,facing=south]{CustomName:"{\"text\":\"Item Sharing Bin\"}"}
effect give @e[type=villager,tag=startV] resistance 1000000 255 true
effect give @e[type=villager,tag=startV] regeneration 1000000 255 true
effect give @e[type=villager,tag=startV] invisibility 1000000 0 true
effect give @e[type=slime,tag=mineSlime] resistance 1000000 255 true
effect give @e[type=slime,tag=mineSlime] regeneration 1000000 255 true
effect give @e[type=slime,tag=mineSlime] invisibility 1000000 0 true
effect give @e[type=slime,tag=blocker] resistance 1000000 255 true
effect give @e[type=slime,tag=blocker] regeneration 1000000 255 true
effect give @e[type=slime,tag=blocker] invisibility 1000000 0 true
execute as @e[type=trident,nbt={inGround:1b}] unless entity @s[nbt={Trident:{tag:{Enchantments:[{}]}}}] run scoreboard players add @s tridentDespawn 1
execute as @e[type=trident,scores={tridentDespawn=100..},nbt={inGround:1b}] unless entity @s[nbt={Trident:{tag:{Enchantments:[{}]}}}] run kill @s
execute unless entity @a run scoreboard objectives setdisplay sidebar

#info
scoreboard players reset @a[scores={infoTimer=100}] infoTimer
scoreboard players add @a[scores={infoTimer=0..99}] infoTimer 1

#fix orientation
function main:fix_orientation

#start
function main:starting

#stopwatch
scoreboard players add @e[type=armor_stand,tag=as] second 0
scoreboard players add @e[type=armor_stand,tag=as] minute 0
scoreboard players add @e[type=armor_stand,tag=as] hour 0
scoreboard players add @e[type=armor_stand,tag=stopwatch] tick 1
scoreboard players add @e[type=armor_stand,tag=stopwatch,scores={tick=20..}] second 1
scoreboard players set @e[type=armor_stand,tag=stopwatch,scores={tick=20..}] tick 0
scoreboard players add @e[type=armor_stand,tag=stopwatch,scores={second=60..}] minute 1
scoreboard players set @e[type=armor_stand,tag=stopwatch,scores={second=60..}] second 0
scoreboard players add @e[type=armor_stand,tag=stopwatch,scores={minute=60..}] hour 1
scoreboard players set @e[type=armor_stand,tag=stopwatch,scores={minute=60..}] minute 0

#idol info
function main:idol_info

#teleporters
function main:teleporters/main

#mob hp
function main:mobhp/main

#underwater mines
function main:mines/main

#vortex trap
function main:vortex/main

#revival idol
function main:idol

# axolotl
execute as @a[tag=!inArena,scores={placeAxolotl=1..}] at @s run function main:regive_axolotl
scoreboard players reset @a placeAxolotl
clear @a bucket
execute as @e[type=axolotl,tag=axolotl,tag=new] at @s run function main:axolotl

#anti-out of map when spectating
tag @a[gamemode=spectator] add spec
tag @a[gamemode=!spectator] remove spec
execute as @a[tag=spec,tag=!inArena] run tp @s @p[tag=inArena]
execute as @a store result score @s yLevel run data get entity @s Pos[1]
execute as @a[tag=spec,scores={yLevel=150..}] at @s run tp @s ~ 140 ~
execute as @a[tag=!spec,scores={yLevel=251..}] at @s run tp @s ~ 250 ~
execute as @a[scores={yLevel=..50}] at @s run tp @s 5 113.5 1 90 0

#spectate
scoreboard players enable @a[tag=inSpawn] Spectate
team join spec @a[scores={Spectate=1..}]
execute as @a[scores={Spectate=1..}] run tp @p[team=player,tag=!spec]
scoreboard players reset @a Spectate

#bossbar
bossbar set underwater_mob_arena:wave players @a[tag=!inSpawn]
scoreboard players add @e[type=armor_stand,tag=as] wave 0
execute store result bossbar underwater_mob_arena:wave value run scoreboard players get @e[type=armor_stand,tag=as,limit=1] wave
execute as @e[type=armor_stand,tag=as] unless entity @s[scores={startTimer=0..}] run bossbar set underwater_mob_arena:wave visible true
execute unless entity @e[type=armor_stand,tag=as] run bossbar set underwater_mob_arena:wave visible false

#glowing
execute if entity @e[type=armor_stand,tag=as,scores={killCounter=..5}] run effect give @e[team=mob] glowing 1 0 true
execute if entity @e[type=armor_stand,tag=as] run effect give @e[type=drowned,tag=tank] glowing 1 0 true

#puffer spawner
execute as @e[type=drowned,tag=pufferSpawner] unless entity @s[scores={pufferTimer=600..}] run scoreboard players add @s pufferTimer 1
execute as @e[type=drowned,tag=pufferSpawner,scores={pufferTimer=600..}] at @s if block ~ ~3 ~ water if entity @a[distance=..15] run summon pufferfish ~ ~3 ~ {Tags:["pufferfish1"],PersistenceRequired:1,CustomName:"{\"text\":\"Pufferfish\",\"color\":\"red\"}"}
execute as @e[type=drowned,tag=pufferSpawner,scores={pufferTimer=600..}] at @s if block ~ ~3 ~ water if entity @a[distance=..15] run scoreboard players set @s pufferTimer 0

#rejoin
execute as @a[scores={rejoin=1..}] at @s run function main:rejoin

#archery
function main:archery/main

#death
tag @a[scores={death=1..}] add dead
gamemode spectator @a[scores={death=1..}]
execute as @a[scores={death=1..}] run execute at @a run playsound minecraft:entity.wither.break_block master @a ~ ~ ~ 9999
scoreboard players set @a[scores={kbDrowned=1..}] kb 1
scoreboard players set @a[scores={kbGuardian=1..}] kb 1
scoreboard players set @a[scores={kbEGuardian=1..}] kb 1
scoreboard players set @a[scores={kbPufferfish=1..}] kb 1

#loss
scoreboard players set @e[type=armor_stand,tag=as] players 0
execute as @a[tag=!dead,team=player] run scoreboard players add @e[type=armor_stand,tag=as] players 1
function main:death_msgs
execute if entity @e[type=armor_stand,tag=as,limit=1,scores={players=0}] run function main:game/loss

#low hp alerts
execute as @a[tag=!dead,scores={health=1..4}] unless entity @s[scores={hpTimer=0..600}] run tag @s add lowHp
scoreboard players add @a[tag=lowHp] hpTimer 0
execute as @a[tag=lowHp] run tellraw @a[tag=!lowHp] [{"selector":"@s"},{"text":" is low on health!","color":"red"}]
tellraw @a[tag=lowHp] {"text":"You are low on health, get to safety!","color":"red"}
execute as @a[tag=lowHp] at @s run playsound minecraft:entity.wither.hurt ambient @s ~ ~ ~
tag @a remove lowHp
scoreboard players add @a[scores={hpTimer=0..600}] hpTimer 1
scoreboard players reset @a[scores={hpTimer=600..}] hpTimer

#mob teams
team join mob @e[type=pufferfish]
team join mob @e[type=drowned]
team join mob @e[type=guardian]
team join mob @e[type=elder_guardian]

#coins
execute as @a store result score @s coins run clear @s sunflower{coin:1b} 0
xp set @a 0 levels
xp set @a 0 points

#shop item armor stand rotation
execute as @e[type=minecraft:armor_stand,tag=rotate] at @s run tp @s ~ ~ ~ ~2 ~

#effects
effect give @a conduit_power 100000 255 true
effect give @a night_vision 1000000 0 true

#kill counter
scoreboard players set @e[type=armor_stand,tag=as,scores={killCounter=0..}] killCounter 0
execute as @e[team=mob] run scoreboard players add @e[type=armor_stand,tag=as] killCounter 1

#mobs remaining title
execute as @e[type=armor_stand,tag=as,scores={killCounter=2..10}] run title @a actionbar ["",{"score":{"name":"@e[type=armor_stand,tag=as,limit=1]","objective":"killCounter"},"bold":true,"color":"red"},{"text":" enemies remaining","color":"red"}]
execute as @e[type=armor_stand,tag=as,scores={killCounter=1}] run title @a actionbar ["",{"score":{"name":"@e[type=armor_stand,tag=as,limit=1]","objective":"killCounter"},"bold":true,"color":"red"},{"text":" enemy remaining","color":"red"}]

#end wave
execute as @e[type=minecraft:armor_stand,limit=1,tag=as,scores={killCounter=0}] at @s run tp ~2 ~ ~
execute as @e[type=armor_stand,tag=as,scores={killCounter=0}] run title @a actionbar [{"text":"0","color":"red","bold":"true","underlined":"true"},{"text":" enemies remaining","color":"red","bold":"false","underlined":"false"}]
execute as @e[type=armor_stand,tag=as,scores={killCounter=0}] run scoreboard players reset @s killCounter

# unknown bug tping dead player in singleplayer (unknown if in multiplayer) above shop after dying and game ending
execute as @a[x=-33,y=120,z=13,dx=5,dy=-4,dz=5] at @s run function main:above_shop_bug